#ifndef SCENEMULTIPLEOBJECTS_H
#define SCENEMULTIPLEOBJECTS_H

#include "scene.h"
#include "glslprogram.h"
#include "cube.h"
#include "sphere.h"

#include <glm/glm.hpp>
using glm::mat4;

class SceneMultipleObjects : public Scene
{
private:
    GLSLProgram prog;
    GLuint brick, moss, leaves;

    Cube cube;
    Sphere sphere;
    float angle;

    void setMatrices();
    void compileAndLinkShader();

public:
    SceneMultipleObjects();

    void initScene();
    void update(float t);
    void render();
    void renderObjects(mat4 model);
    void resize(int, int, float);
};
#endif
