#include "scene.h"
#include "scenerunner.h"
#include "scenetexture.h"
#include "scenemultitex.h"
#include "scenesamplerobj.h"
#include "scenemultipleobjects.h"

std::map<std::string, std::string> sceneInfo = {
	{ "multi-tex", "Multiple textures" },
	{ "sampler-obj", "Sampler objects " },
	{ "texture", "Basic texture mapping" },
};

int main(int argc, char *argv[])
{

	std::string recipe = SceneRunner::parseCLArgs(argc, argv, sceneInfo);

	SceneRunner runner("Chapter 5 - " + recipe, 1024, 678, 4);
	std::unique_ptr<Scene> scene;
	if( recipe == "multi-tex") {
		scene = std::unique_ptr<Scene>( new SceneMultiTex() ); 
	} else if( recipe == "sampler-obj" ) {
		scene = std::unique_ptr<Scene>( new SceneSamplerObj() );
	} else if( recipe == "texture" ) {
		scene = std::unique_ptr<Scene>( new SceneTexture() );
	}
	else {
		printf("Unknown recipe: %s\n", recipe.c_str());
		exit(EXIT_FAILURE);
	}

    return runner.run(std::move(scene));
}
